//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_color5  LimeGreen
#property indicator_color6  PaleVioletRed
#property indicator_color7  PaleVioletRed
#property indicator_style3  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_level1  0
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2

extern int    DrawBars      = 0;
extern int    BBPeriod      = 15;
extern int    BBPrice       = PRICE_WEIGHTED;
extern double BBDeviations  = 2.0;
extern int    HullPeriod    = 14;
extern int    HullPrice     = PRICE_CLOSE;
extern color  WickColor     = Gray;
extern color  BodyUpColor   = LimeGreen;
extern color  BodyDownColor = PaleVioletRed;
extern int    BodyWidth     = 3;
extern bool   DrawAsBack    = false;
extern string UniqueID      = "BB bars 1";

//
//
//
//
//

double max[];
double min[];
double hull[];
double hullDa[];
double hullDb[];
double bandUp[];
double bandDn[];
double trend[];
int    window;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,max); SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(1,min); SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(2,bandUp);
   SetIndexBuffer(3,bandDn);
   SetIndexBuffer(4,hull);
   SetIndexBuffer(5,hullDa);
   SetIndexBuffer(6,hullDb);
   SetIndexBuffer(7,trend);
	IndicatorShortName(UniqueID); 
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i); if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

double work[][4];
#define _open  0
#define _close 1
#define _high  2
#define _low   3

int start()
{
   int i,r,countedBars = IndicatorCounted();
      if (countedBars<0) return(-1);
      if (countedBars>0) countedBars--;
         int drawBars = DrawBars; if (drawBars<1) drawBars = Bars;
         int limit = MathMin(MathMin(Bars-countedBars,Bars-1),drawBars);
            window = WindowFind(UniqueID);
            if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   if (trend[limit]==-1) CleanPoint(limit,hullDa,hullDb);
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double deviation = iStdDev(NULL,0,BBPeriod,0,MODE_SMA,BBPrice,i);
      double ma        = iMA(NULL,0,BBPeriod,0,MODE_SMA,BBPrice,i);
         bandUp[i] =  BBDeviations*deviation;
         bandDn[i] = -BBDeviations*deviation;
         work[r][_open]  = Open[i] -ma;
         work[r][_close] = Close[i]-ma;
         work[r][_high]  = High[i] -ma;
         work[r][_low]   = Low[i]  -ma;
         drawCandle(i);
         
         //
         //
         //
         //
         //
         
         hull[i]   = iHull(getPrice(HullPrice,i),HullPeriod,i,0);
         hullDa[i] = EMPTY_VALUE;
         hullDb[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (hull[i]>hull[i+1]) trend[i] =  1;
            if (hull[i]<hull[i+1]) trend[i] = -1;
            if (trend[i]==-1) PlotPoint(i,hullDa,hullDb,hull);
         max[i] = MathMax(MathMax(work[r][_high],hull[i]),bandUp[i]);
         min[i] = MathMin(MathMin(work[r][_high],hull[i]),bandUp[i]);
   }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double getPrice(int type, int i)
{
   int r = Bars-i-1;
   switch (type)
   {
      case 0:   return(work[r][_close]);
      case 1:   return(work[r][_open]);
      case 2:   return(work[r][_high]);
      case 3:   return(work[r][_low]);
      case 4:   return((work[r][_high]+work[r][_low])/2.0);
      case 5:   return((work[r][_high]+work[r][_low]+work[r][_close])/3.0);
      case 6:   return((work[r][_high]+work[r][_low]+work[r][_close]+work[r][_close])/4.0);
   }
   return(work[r][_close]);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//


double workHull[][2];
double iHull(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workHull,0)!= Bars) ArrayResize(workHull,Bars); r=Bars-r-1;

   //
   //
   //
   //
   //

      int HmaPeriod  = MathMax(period,2);
      int HalfPeriod = MathFloor(HmaPeriod/2);
      int HullPeriod = MathFloor(MathSqrt(HmaPeriod));
      double hma,hmw,weight; instanceNo *= 2;

         workHull[r][instanceNo] = price;

         //
         //
         //
         //
         //
               
         hmw = HalfPeriod; hma = hmw*price; 
            for(int k=1; k<HalfPeriod && (r-k)>=0; k++)
            {
               weight = HalfPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];  
            }             
            workHull[r][instanceNo+1] = 2.0*hma/hmw;

         hmw = HmaPeriod; hma = hmw*price; 
            for(k=1; k<period && (r-k)>=0; k++)
            {
               weight = HmaPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];
            }             
            workHull[r][instanceNo+1] -= hma/hmw;

         //
         //
         //
         //
         //
         
         hmw = HullPeriod; hma = hmw*workHull[r][instanceNo+1];
            for(k=1; k<HullPeriod && (r-k)>=0; k++)
            {
               weight = HullPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][1+instanceNo];  
            }
   return(hma/hmw);
}
 
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
  
void drawCandle(int i)
{
   datetime time = Time[i]; int r = Bars-i-1;
   string   name = UniqueID+":"+time+":";
   
      ObjectCreate(name,OBJ_TREND,window,0,0,0,0);
         ObjectSet(name,OBJPROP_COLOR,WickColor);
         ObjectSet(name,OBJPROP_TIME1,time);
         ObjectSet(name,OBJPROP_TIME2,time);
         ObjectSet(name,OBJPROP_PRICE1,MathMax(work[r][_high],MathMin(work[r][_close],work[r][_open])));
         ObjectSet(name,OBJPROP_PRICE2,MathMin(work[r][_low] ,MathMax(work[r][_close],work[r][_open])));
         ObjectSet(name,OBJPROP_RAY ,false);
         ObjectSet(name,OBJPROP_BACK,DrawAsBack);
      
   //
   //
   //
   //
   //
         
   name = name+"body";
      ObjectCreate(name,OBJ_TREND,window,0,0,0,0);
         ObjectSet(name,OBJPROP_TIME1,time);
         ObjectSet(name,OBJPROP_TIME2,time);
         ObjectSet(name,OBJPROP_PRICE1,work[r][_open]);
         ObjectSet(name,OBJPROP_PRICE2,work[r][_close]);
         ObjectSet(name,OBJPROP_WIDTH,BodyWidth);
         ObjectSet(name,OBJPROP_RAY  ,false);
         ObjectSet(name,OBJPROP_BACK,DrawAsBack);
         if (work[r][_open]<work[r][_close])
               ObjectSet(name,OBJPROP_COLOR,BodyUpColor);
         else  ObjectSet(name,OBJPROP_COLOR,BodyDownColor);
}